# all files / ol/format/ gml3.js

97.49% Statements 389/399
82.89% Branches 126/152
100% Functions 41/41
97.49% Lines 389/399

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659
    660
    661
    662
    663
    664
    665
    666
    667
    668
    669
    670
    671
    672
    673
    674
    675
    676
    677
    678
    679
    680
    681
    682
    683
    684
    685
    686
    687
    688
    689
    690
    691
    692
    693
    694
    695
    696
    697
    698
    699
    700
    701
    702
    703
    704
    705
    706
    707
    708
    709
    710
    711
    712
    713
    714
    715
    716
    717
    718
    719
    720
    721
    722
    723
    724
    725
    726
    727
    728
    729
    730
    731
    732
    733
    734
    735
    736
    737
    738
    739
    740
    741
    742
    743
    744
    745
    746
    747
    748
    749
    750
    751
    752
    753
    754
    755
    756
    757
    758
    759
    760
    761
    762
    763
    764
    765
    766
    767
    768
    769
    770
    771
    772
    773
    774
    775
    776
    777
    778
    779
    780
    781
    782
    783
    784
    785
    786
    787
    788
    789
    790
    791
    792
    793
    794
    795
    796
    797
    798
    799
    800
    801
    802
    803
    804
    805
    806
    807
    808
    809
    810
    811
    812
    813
    814
    815
    816
    817
    818
    819
    820
    821
    822
    823
    824
    825
    826
    827
    828
    829
    830
    831
    832
    833
    834
    835
    836
    837
    838
    839
    840
    841
    842
    843
    844
    845
    846
    847
    848
    849
    850
    851
    852
    853
    854
    855
    856
    857
    858
    859
    860
    861
    862
    863
    864
    865
    866
    867
    868
    869
    870
    871
    872
    873
    874
    875
    876
    877
    878
    879
    880
    881
    882
    883
    884
    885
    886
    887
    888
    889
    890
    891
    892
    893
    894
    895
    896
    897
    898
    899
    900
    901
    902
    903
    904
    905
    906
    907
    908
    909
    910
    911
    912
    913
    914
    915
    916
    917
    918
    919
    920
    921
    922
    923
    924
    925
    926
    927
    928
    929
    930
    931
    932
    933
    934
    935
    936
    937
    938
    939
    940
    941
    942
    943
    944
    945
    946
    947
    948
    949
    950
    951
    952
    953
    954
    955
    956
    957
    958
    959
    960
    961
    962
    963
    964
    965
    966
    967
    968
    969
    970
    971
    972
    973
    974
    975
    976
    977
    978
    979
    980
    981
    982
    983
    984
    985
    986
    987
    988
    989
    990
    991
    992
    993
    994
    995
    996
    997
    998
    999
    1000
    1001
    1002
    1003
    1004
    1005
    1006
    1007
    1008
    1009
    1010
    1011
    1012
    1013
    1014
    1015
    1016
    1017
    1018
    1019
    1020
    1021
    1022
    1023
    1024
    1025
    1026
    1027
    1028
    1029
    1030
    1031
    1032
    1033
    1034
    1035
    1036
    1037
    1038
    1039
    1040
    1041
    1042
    1043
    1044
    1045
    1046
    1047
    1048
    1049
    1050
    1051
    1052
    1053
    1054
    1055
    1056
    1057
    1058
    1059
    1060
    1061
    1062
    1063
    1064
    1065
    1066
    1067
    1068
    1069
    1070
    1071
    1072
    1073
    1074
    1075
    1076
    1077
    1078
    1079
    1080
    1081
    1082
    1083
    1084
    1085
    1086
    1087
    1088
    1089
    1090
    1091
    1092
    1093
    1094
    1095
    1096
    1097
    1098
    1099
    1100
    1101
    1102
    1103
    1104
    1105
    1106
    1107
    1108
    1109
    1110
    1111
    1112
    1113
    1114
    1115
    1116
    1117
    1118
    1119
    1120
    1121
    1122
    1123
    1124
    1125
    1126
    1127
    1128
    1129
    1130
    1131
    1132
    1133
    1134
    1135
    1136
    1137
    1138
    1139
    1140
    1141
    1142
    1143
    1144
    1145
    1146
    1147
    1148
    1149
    1150
    1151
    1152
    1153
    1154
    1155
    1156
    1157
    1158
    1159
    1160
    1161
    1162
    1163
    1164
    1165
    1166
    1167
    1168
    1169
    1170
    1171
    1172
    1173
    1174
    1175
    1176
    1177
    1178
    1179
    1180
    1181
    1182
    1183
    1184
    1185
    1186
    1187
    1188
    1189
    1190
    1191
    1192
    1193
    1194
    1195
    1196
    1197
    1198
    1199
    1200
    1201
    1202
    1203
    1204
    1205
    1206
    1207
    1208
    1209
    1210
    1211
    1212
    1213
    1214
    1215
    1216
    1217
    1218
    1219
    1220
    1221
    1222
    1223
    1224
    1225
    1226
    1227
    1228
    1229
    1230
    1231
    1232
    1233
    1234
    1235
    1236
    1237
    1238
    1239
    1240
    1241
    1242
    1243
    1244
    1245
    1246
    1247
    1248
    1249
    1250
    1251
    1252
    1253
    1254
    1255
    1256
    1257
    12581×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×
    222×

    222×

    222×

    222×

    222×

    222×

    222×

    222×

    1×

    1×

    1×

    2×

    2×
    2×
    2×
    2×

    1×

    30×

    30×
    30×
    30×
    30×

    1×
    4×

    1×
    39×

    1×
    3×

    1×
    3×

    1×
    3×

    1×
    3×

    1×

    14×

    14×
    14×

    14×

    1×

    53×

    53×
    53×

    53×

    1×

    3×

    3×
    3×
    3×
    3×
    3×
    3×
    4×
    4×

    3×

    3×

    1×

    3×

    3×
    3×
    3×
    3×

    1×

    24×

    24×

    1×
    19×
    19×

    19×
    19×
    19×
    39×
    39×

    19×

    19×
    19×
    19×
    19×
    18×
    18×

    19×
    7×
    7×
    7×
    7×
    7×
    7×

    19×
    19×
    18×

    19×

    19×

    1×
    133×
    133×
    133×
    133×
    133×
    133×
    133×
    133×

    133×

    133×
    133×
    53×

    80×

    80×
    6×

    74×
    1×

    133×
    133×
    133×
    4101×
    4101×
    4101×
    4101×
    185×

    3916×

    133×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    13×
    13×
    13×
    13×
    13×
    13×
    13×
    7×

    13×
    13×

    13×
    11×

    2×

    13×

    2×
    2×

    13×

    1×
    2462×
    2462×
    2452×

    2462×

    2462×

    2462×

    1×
    54×
    54×
    54×
    54×
    54×

    54×
    54×
    54×
    54×
    54×
    2462×
    2462×

    54×

    1×
    13×
    13×
    13×
    7×

    13×
    13×
    13×

    1×

    1×
    2×
    2×
    2×
    2×

    2×
    2×
    2×

    1×
    38×
    38×
    38×
    36×

    38×
    38×
    38×

    1×
    37×
    37×
    37×
    37×
    27×

    37×

    1×
    30×
    30×
    30×
    30×
    25×

    30×
    27×
    27×

    3×
    3×
    3×
    3×

    1×
    19×
    19×
    19×
    16×

    19×

    16×
    16×
    16×
    3×
    3×
    3×
    3×

    1×
    14×
    14×
    14×
    14×
    14×
    14×

    14×
    14×

    1×

    7×
    7×
    7×
    7×
    1×

    7×
    7×

    1×
    8×
    8×
    8×
    8×
    8×
    8×

    8×
    8×

    1×
    37×
    37×
    37×

    1×
    23×

    23×
    23×
    23×

    1×
    9×
    9×
    9×

    1×
    11×
    11×
    11×
    11×

    1×
    3×
    3×
    3×

    1×
    3×

    3×
    3×

    1×
    45×
    45×
    45×
    45×
    45×
    2×

    2×

    43×

    45×

    1×
    15×
    15×
    10×

    15×
    15×
    15×
    15×
    6×
    6×

    15×
    15×
    15×
    243×
    243×
    240×
    240×
    240×
    16×
    7×

    224×
    26×

    15×
    15×
    15×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    34×
    34×

    1×
    79×
    79×
    79×
    79×
    79×
    79×
    79×
    77×
    77×
    13×
    64×
    3×
    61×
    3×
    58×
    3×

    2×

    79×

    1×
    20×
    20×
    20×

    20×
    20×

    20×
    20×

    1×

    1×
    1×
    1×

    1×

    1×

    1×
    1×

    1×
    1×

     goog.provide('ol.format.GML3');

    goog.require('ol');
    goog.require('ol.array');
    goog.require('ol.extent');
    goog.require('ol.format.Feature');
    goog.require('ol.format.GMLBase');
    goog.require('ol.format.XSD');
    goog.require('ol.geom.Geometry');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.LineString');
    goog.require('ol.geom.MultiLineString');
    goog.require('ol.geom.MultiPolygon');
    goog.require('ol.geom.Polygon');
    goog.require('ol.obj');
    goog.require('ol.proj');
    goog.require('ol.xml');

    /**
     * @classdesc
     * Feature format for reading and writing data in the GML format
     * version 3.1.1.
     * Currently only supports GML 3.1.1 Simple Features profile.
     *
     * @constructor
     * @param {olx.format.GMLOptions=} opt_options
     *     Optional configuration object.
     * @extends {ol.format.GMLBase}
     * @api
     */
    ol.format.GML3 = function(opt_options) {
      var options = /** @type {olx.format.GMLOptions} */
          (opt_options ? opt_options : {});

      ol.format.GMLBase.call(this, options);

      /**
       * @private
       * @type {boolean}
       */
      this.surface_ = options.surface !== undefined ? options.surface : false;

      /**
       * @private
       * @type {boolean}
       */
      this.curve_ = options.curve !== undefined ? options.curve : false;

      /**
       * @private
       * @type {boolean}
       */
      this.multiCurve_ = options.multiCurve !== undefined ?
        options.multiCurve : true;

      /**
       * @private
       * @type {boolean}
       */
      this.multiSurface_ = options.multiSurface !== undefined ?
        options.multiSurface : true;

      /**
       * @inheritDoc
       */
      this.schemaLocation = options.schemaLocation ?
        options.schemaLocation : ol.format.GML3.schemaLocation_;

      /**
       * @private
       * @type {boolean}
       */
      this.hasZ = options.hasZ !== undefined ?
        options.hasZ : false;

    };
    ol.inherits(ol.format.GML3, ol.format.GMLBase);

    /**
     * @const
     * @type {string}
     * @private
     */
    ol.format.GML3.schemaLocation_ = ol.format.GMLBase.GMLNS +
        ' http://schemas.opengis.net/gml/3.1.1/profiles/gmlsfProfile/' +
        '1.0.0/gmlsf.xsd';

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.MultiLineString|undefined} MultiLineString.
     */
    ol.format.GML3.prototype.readMultiCurve_ = function(node, objectStack) {
      /** @type {Array.<ol.geom.LineString>} */
      var lineStrings = ol.xml.pushParseAndPop([],
          this.MULTICURVE_PARSERS_, node, objectStack, this);
      Eif (lineStrings) {
        var multiLineString = new ol.geom.MultiLineString(null);
        multiLineString.setLineStrings(lineStrings);
        return multiLineString;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.MultiPolygon|undefined} MultiPolygon.
     */
    ol.format.GML3.prototype.readMultiSurface_ = function(node, objectStack) {
      /** @type {Array.<ol.geom.Polygon>} */
      var polygons = ol.xml.pushParseAndPop([],
          this.MULTISURFACE_PARSERS_, node, objectStack, this);
      Eif (polygons) {
        var multiPolygon = new ol.geom.MultiPolygon(null);
        multiPolygon.setPolygons(polygons);
        return multiPolygon;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.GML3.prototype.curveMemberParser_ = function(node, objectStack) {
      ol.xml.parseNode(this.CURVEMEMBER_PARSERS_, node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.GML3.prototype.surfaceMemberParser_ = function(node, objectStack) {
      ol.xml.parseNode(this.SURFACEMEMBER_PARSERS_,
          node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<(Array.<number>)>|undefined} flat coordinates.
     */
    ol.format.GML3.prototype.readPatch_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop([null],
          this.PATCHES_PARSERS_, node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>|undefined} flat coordinates.
     */
    ol.format.GML3.prototype.readSegment_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop([null],
          this.SEGMENTS_PARSERS_, node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<(Array.<number>)>|undefined} flat coordinates.
     */
    ol.format.GML3.prototype.readPolygonPatch_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop([null],
          this.FLAT_LINEAR_RINGS_PARSERS_, node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>|undefined} flat coordinates.
     */
    ol.format.GML3.prototype.readLineStringSegment_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop([null],
          this.GEOMETRY_FLAT_COORDINATES_PARSERS_,
          node, objectStack, this);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.GML3.prototype.interiorParser_ = function(node, objectStack) {
      /** @type {Array.<number>|undefined} */
      var flatLinearRing = ol.xml.pushParseAndPop(undefined,
          this.RING_PARSERS, node, objectStack, this);
      Eif (flatLinearRing) {
        var flatLinearRings = /** @type {Array.<Array.<number>>} */
            (objectStack[objectStack.length - 1]);
        flatLinearRings.push(flatLinearRing);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.GML3.prototype.exteriorParser_ = function(node, objectStack) {
      /** @type {Array.<number>|undefined} */
      var flatLinearRing = ol.xml.pushParseAndPop(undefined,
          this.RING_PARSERS, node, objectStack, this);
      Eif (flatLinearRing) {
        var flatLinearRings = /** @type {Array.<Array.<number>>} */
            (objectStack[objectStack.length - 1]);
        flatLinearRings[0] = flatLinearRing;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.Polygon|undefined} Polygon.
     */
    ol.format.GML3.prototype.readSurface_ = function(node, objectStack) {
      /** @type {Array.<Array.<number>>} */
      var flatLinearRings = ol.xml.pushParseAndPop([null],
          this.SURFACE_PARSERS_, node, objectStack, this);
      Eif (flatLinearRings && flatLinearRings[0]) {
        var polygon = new ol.geom.Polygon(null);
        var flatCoordinates = flatLinearRings[0];
        var ends = [flatCoordinates.length];
        var i, ii;
        for (i = 1, ii = flatLinearRings.length; i < ii; ++i) {
          ol.array.extend(flatCoordinates, flatLinearRings[i]);
          ends.push(flatCoordinates.length);
        }
        polygon.setFlatCoordinates(
            ol.geom.GeometryLayout.XYZ, flatCoordinates, ends);
        return polygon;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.LineString|undefined} LineString.
     */
    ol.format.GML3.prototype.readCurve_ = function(node, objectStack) {
      /** @type {Array.<number>} */
      var flatCoordinates = ol.xml.pushParseAndPop([null],
          this.CURVE_PARSERS_, node, objectStack, this);
      Eif (flatCoordinates) {
        var lineString = new ol.geom.LineString(null);
        lineString.setFlatCoordinates(ol.geom.GeometryLayout.XYZ, flatCoordinates);
        return lineString;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.Extent|undefined} Envelope.
     */
    ol.format.GML3.prototype.readEnvelope_ = function(node, objectStack) {
      /** @type {Array.<number>} */
      var flatCoordinates = ol.xml.pushParseAndPop([null],
          this.ENVELOPE_PARSERS_, node, objectStack, this);
      return ol.extent.createOrUpdate(flatCoordinates[1][0],
          flatCoordinates[1][1], flatCoordinates[2][0],
          flatCoordinates[2][1]);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>|undefined} Flat coordinates.
     */
    ol.format.GML3.prototype.readFlatPos_ = function(node, objectStack) {
      var s = ol.xml.getAllTextContent(node, false);
      var re = /^\s*([+\-]?\d*\.?\d+(?:[eE][+\-]?\d+)?)\s*/;
      /** @type {Array.<number>} */
      var flatCoordinates = [];
      var m;
      while ((m = re.exec(s))) {
        flatCoordinates.push(parseFloat(m[1]));
        s = s.substr(m[0].length);
      }
      Iif (s !== '') {
        return undefined;
      }
      var context = objectStack[0];
      var containerSrs = context['srsName'];
      var axisOrientation = 'enu';
      if (containerSrs) {
        var proj = ol.proj.get(containerSrs);
        axisOrientation = proj.getAxisOrientation();
      }
      if (axisOrientation === 'neu') {
        var i, ii;
        for (i = 0, ii = flatCoordinates.length; i < ii; i += 3) {
          var y = flatCoordinates[i];
          var x = flatCoordinates[i + 1];
          flatCoordinates[i] = x;
          flatCoordinates[i + 1] = y;
        }
      }
      var len = flatCoordinates.length;
      if (len == 2) {
        flatCoordinates.push(0);
      }
      Iif (len === 0) {
        return undefined;
      }
      return flatCoordinates;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>|undefined} Flat coordinates.
     */
    ol.format.GML3.prototype.readFlatPosList_ = function(node, objectStack) {
      var s = ol.xml.getAllTextContent(node, false).replace(/^\s*|\s*$/g, '');
      var context = objectStack[0];
      var containerSrs = context['srsName'];
      var contextDimension = context['srsDimension'];
      var axisOrientation = 'enu';
      Eif (containerSrs) {
        var proj = ol.proj.get(containerSrs);
        axisOrientation = proj.getAxisOrientation();
      }
      var coords = s.split(/\s+/);
      // The "dimension" attribute is from the GML 3.0.1 spec.
      var dim = 2;
      if (node.getAttribute('srsDimension')) {
        dim = ol.format.XSD.readNonNegativeIntegerString(
            node.getAttribute('srsDimension'));
      } else Iif (node.getAttribute('dimension')) {
        dim = ol.format.XSD.readNonNegativeIntegerString(
            node.getAttribute('dimension'));
      } else if (node.parentNode.getAttribute('srsDimension')) {
        dim = ol.format.XSD.readNonNegativeIntegerString(
            node.parentNode.getAttribute('srsDimension'));
      } else if (contextDimension) {
        dim = ol.format.XSD.readNonNegativeIntegerString(contextDimension);
      }
      var x, y, z;
      var flatCoordinates = [];
      for (var i = 0, ii = coords.length; i < ii; i += dim) {
        x = parseFloat(coords[i]);
        y = parseFloat(coords[i + 1]);
        z = (dim === 3) ? parseFloat(coords[i + 2]) : 0;
        if (axisOrientation.substr(0, 2) === 'en') {
          flatCoordinates.push(x, y, z);
        } else {
          flatCoordinates.push(y, x, z);
        }
      }
      return flatCoordinates;
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.GEOMETRY_FLAT_COORDINATES_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'pos': ol.xml.makeReplacer(ol.format.GML3.prototype.readFlatPos_),
        'posList': ol.xml.makeReplacer(ol.format.GML3.prototype.readFlatPosList_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.FLAT_LINEAR_RINGS_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'interior': ol.format.GML3.prototype.interiorParser_,
        'exterior': ol.format.GML3.prototype.exteriorParser_
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.GEOMETRY_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'Point': ol.xml.makeReplacer(ol.format.GMLBase.prototype.readPoint),
        'MultiPoint': ol.xml.makeReplacer(
            ol.format.GMLBase.prototype.readMultiPoint),
        'LineString': ol.xml.makeReplacer(
            ol.format.GMLBase.prototype.readLineString),
        'MultiLineString': ol.xml.makeReplacer(
            ol.format.GMLBase.prototype.readMultiLineString),
        'LinearRing': ol.xml.makeReplacer(
            ol.format.GMLBase.prototype.readLinearRing),
        'Polygon': ol.xml.makeReplacer(ol.format.GMLBase.prototype.readPolygon),
        'MultiPolygon': ol.xml.makeReplacer(
            ol.format.GMLBase.prototype.readMultiPolygon),
        'Surface': ol.xml.makeReplacer(ol.format.GML3.prototype.readSurface_),
        'MultiSurface': ol.xml.makeReplacer(
            ol.format.GML3.prototype.readMultiSurface_),
        'Curve': ol.xml.makeReplacer(ol.format.GML3.prototype.readCurve_),
        'MultiCurve': ol.xml.makeReplacer(
            ol.format.GML3.prototype.readMultiCurve_),
        'Envelope': ol.xml.makeReplacer(ol.format.GML3.prototype.readEnvelope_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.MULTICURVE_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'curveMember': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.curveMemberParser_),
        'curveMembers': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.curveMemberParser_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.MULTISURFACE_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'surfaceMember': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.surfaceMemberParser_),
        'surfaceMembers': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.surfaceMemberParser_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.CURVEMEMBER_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'LineString': ol.xml.makeArrayPusher(
            ol.format.GMLBase.prototype.readLineString),
        'Curve': ol.xml.makeArrayPusher(ol.format.GML3.prototype.readCurve_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.SURFACEMEMBER_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'Polygon': ol.xml.makeArrayPusher(ol.format.GMLBase.prototype.readPolygon),
        'Surface': ol.xml.makeArrayPusher(ol.format.GML3.prototype.readSurface_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.SURFACE_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'patches': ol.xml.makeReplacer(ol.format.GML3.prototype.readPatch_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.CURVE_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'segments': ol.xml.makeReplacer(ol.format.GML3.prototype.readSegment_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.ENVELOPE_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'lowerCorner': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.readFlatPosList_),
        'upperCorner': ol.xml.makeArrayPusher(
            ol.format.GML3.prototype.readFlatPosList_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.PATCHES_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'PolygonPatch': ol.xml.makeReplacer(
            ol.format.GML3.prototype.readPolygonPatch_)
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.GML3.prototype.SEGMENTS_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'LineStringSegment': ol.xml.makeReplacer(
            ol.format.GML3.prototype.readLineStringSegment_)
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Point} value Point geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writePos_ = function(node, value, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var hasZ = context['hasZ'];
      var srsDimension = hasZ ? 3 : 2;
      node.setAttribute('srsDimension', srsDimension);
      var srsName = context['srsName'];
      var axisOrientation = 'enu';
      if (srsName) {
        axisOrientation = ol.proj.get(srsName).getAxisOrientation();
      }
      var point = value.getCoordinates();
      var coords;
      // only 2d for simple features profile
      if (axisOrientation.substr(0, 2) === 'en') {
        coords = (point[0] + ' ' + point[1]);
      } else {
        coords = (point[1] + ' ' + point[0]);
      }
      if (hasZ) {
        // For newly created points, Z can be undefined.
        var z = point[2] || 0;
        coords += ' ' + z;
      }
      ol.format.XSD.writeStringTextNode(node, coords);
    };

    /**
     * @param {Array.<number>} point Point geometry.
     * @param {string=} opt_srsName Optional srsName
     * @param {boolean=} opt_hasZ whether the geometry has a Z coordinate (is 3D) or not.
     * @return {string} The coords string.
     * @private
     */
    ol.format.GML3.prototype.getCoords_ = function(point, opt_srsName, opt_hasZ) {
      var axisOrientation = 'enu';
      if (opt_srsName) {
        axisOrientation = ol.proj.get(opt_srsName).getAxisOrientation();
      }
      var coords = ((axisOrientation.substr(0, 2) === 'en') ?
        point[0] + ' ' + point[1] :
        point[1] + ' ' + point[0]);
      Iif (opt_hasZ) {
        // For newly created points, Z can be undefined.
        var z = point[2] || 0;
        coords += ' ' + z;
      }

      return coords;
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LineString|ol.geom.LinearRing} value Geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writePosList_ = function(node, value, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var hasZ = context['hasZ'];
      var srsDimension = hasZ ? 3 : 2;
      node.setAttribute('srsDimension', srsDimension);
      var srsName = context['srsName'];
      // only 2d for simple features profile
      var points = value.getCoordinates();
      var len = points.length;
      var parts = new Array(len);
      var point;
      for (var i = 0; i < len; ++i) {
        point = points[i];
        parts[i] = this.getCoords_(point, srsName, hasZ);
      }
      ol.format.XSD.writeStringTextNode(node, parts.join(' '));
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Point} geometry Point geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writePoint_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var srsName = context['srsName'];
      if (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var pos = ol.xml.createElementNS(node.namespaceURI, 'pos');
      node.appendChild(pos);
      this.writePos_(pos, geometry, objectStack);
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.ENVELOPE_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'lowerCorner': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode),
        'upperCorner': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode)
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.Extent} extent Extent.
     * @param {Array.<*>} objectStack Node stack.
     */
    ol.format.GML3.prototype.writeEnvelope = function(node, extent, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var srsName = context['srsName'];
      Eif (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var keys = ['lowerCorner', 'upperCorner'];
      var values = [extent[0] + ' ' + extent[1], extent[2] + ' ' + extent[3]];
      ol.xml.pushSerializeAndPop(/** @type {ol.XmlNodeStackItem} */
          ({node: node}), ol.format.GML3.ENVELOPE_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY,
          values,
          objectStack, keys, this);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LinearRing} geometry LinearRing geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeLinearRing_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var srsName = context['srsName'];
      if (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var posList = ol.xml.createElementNS(node.namespaceURI, 'posList');
      node.appendChild(posList);
      this.writePosList_(posList, geometry, objectStack);
    };

    /**
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node} Node.
     * @private
     */
    ol.format.GML3.prototype.RING_NODE_FACTORY_ = function(value, objectStack, opt_nodeName) {
      var context = objectStack[objectStack.length - 1];
      var parentNode = context.node;
      var exteriorWritten = context['exteriorWritten'];
      if (exteriorWritten === undefined) {
        context['exteriorWritten'] = true;
      }
      return ol.xml.createElementNS(parentNode.namespaceURI,
          exteriorWritten !== undefined ? 'interior' : 'exterior');
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Polygon} geometry Polygon geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeSurfaceOrPolygon_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var hasZ = context['hasZ'];
      var srsName = context['srsName'];
      if (node.nodeName !== 'PolygonPatch' && srsName) {
        node.setAttribute('srsName', srsName);
      }
      if (node.nodeName === 'Polygon' || node.nodeName === 'PolygonPatch') {
        var rings = geometry.getLinearRings();
        ol.xml.pushSerializeAndPop(
            {node: node, hasZ: hasZ, srsName: srsName},
            ol.format.GML3.RING_SERIALIZERS_,
            this.RING_NODE_FACTORY_,
            rings, objectStack, undefined, this);
      } else Eif (node.nodeName === 'Surface') {
        var patches = ol.xml.createElementNS(node.namespaceURI, 'patches');
        node.appendChild(patches);
        this.writeSurfacePatches_(
            patches, geometry, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LineString} geometry LineString geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeCurveOrLineString_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var srsName = context['srsName'];
      if (node.nodeName !== 'LineStringSegment' && srsName) {
        node.setAttribute('srsName', srsName);
      }
      if (node.nodeName === 'LineString' ||
          node.nodeName === 'LineStringSegment') {
        var posList = ol.xml.createElementNS(node.namespaceURI, 'posList');
        node.appendChild(posList);
        this.writePosList_(posList, geometry, objectStack);
      } else Eif (node.nodeName === 'Curve') {
        var segments = ol.xml.createElementNS(node.namespaceURI, 'segments');
        node.appendChild(segments);
        this.writeCurveSegments_(segments,
            geometry, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.MultiPolygon} geometry MultiPolygon geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeMultiSurfaceOrPolygon_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var hasZ = context['hasZ'];
      var srsName = context['srsName'];
      var surface = context['surface'];
      Eif (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var polygons = geometry.getPolygons();
      ol.xml.pushSerializeAndPop({node: node, hasZ: hasZ, srsName: srsName, surface: surface},
          ol.format.GML3.SURFACEORPOLYGONMEMBER_SERIALIZERS_,
          this.MULTIGEOMETRY_MEMBER_NODE_FACTORY_, polygons,
          objectStack, undefined, this);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.MultiPoint} geometry MultiPoint geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeMultiPoint_ = function(node, geometry,
        objectStack) {
      var context = objectStack[objectStack.length - 1];
      var srsName = context['srsName'];
      var hasZ = context['hasZ'];
      if (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var points = geometry.getPoints();
      ol.xml.pushSerializeAndPop({node: node, hasZ: hasZ, srsName: srsName},
          ol.format.GML3.POINTMEMBER_SERIALIZERS_,
          ol.xml.makeSimpleNodeFactory('pointMember'), points,
          objectStack, undefined, this);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.MultiLineString} geometry MultiLineString geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeMultiCurveOrLineString_ = function(node, geometry, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var hasZ = context['hasZ'];
      var srsName = context['srsName'];
      var curve = context['curve'];
      Eif (srsName) {
        node.setAttribute('srsName', srsName);
      }
      var lines = geometry.getLineStrings();
      ol.xml.pushSerializeAndPop({node: node, hasZ: hasZ, srsName: srsName, curve: curve},
          ol.format.GML3.LINESTRINGORCURVEMEMBER_SERIALIZERS_,
          this.MULTIGEOMETRY_MEMBER_NODE_FACTORY_, lines,
          objectStack, undefined, this);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LinearRing} ring LinearRing geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeRing_ = function(node, ring, objectStack) {
      var linearRing = ol.xml.createElementNS(node.namespaceURI, 'LinearRing');
      node.appendChild(linearRing);
      this.writeLinearRing_(linearRing, ring, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Polygon} polygon Polygon geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeSurfaceOrPolygonMember_ = function(node, polygon, objectStack) {
      var child = this.GEOMETRY_NODE_FACTORY_(
          polygon, objectStack);
      Eif (child) {
        node.appendChild(child);
        this.writeSurfaceOrPolygon_(child, polygon, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Point} point Point geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writePointMember_ = function(node, point, objectStack) {
      var child = ol.xml.createElementNS(node.namespaceURI, 'Point');
      node.appendChild(child);
      this.writePoint_(child, point, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LineString} line LineString geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeLineStringOrCurveMember_ = function(node, line, objectStack) {
      var child = this.GEOMETRY_NODE_FACTORY_(line, objectStack);
      Eif (child) {
        node.appendChild(child);
        this.writeCurveOrLineString_(child, line, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Polygon} polygon Polygon geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeSurfacePatches_ = function(node, polygon, objectStack) {
      var child = ol.xml.createElementNS(node.namespaceURI, 'PolygonPatch');
      node.appendChild(child);
      this.writeSurfaceOrPolygon_(child, polygon, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LineString} line LineString geometry.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeCurveSegments_ = function(node, line, objectStack) {
      var child = ol.xml.createElementNS(node.namespaceURI,
          'LineStringSegment');
      node.appendChild(child);
      this.writeCurveOrLineString_(child, line, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Geometry|ol.Extent} geometry Geometry.
     * @param {Array.<*>} objectStack Node stack.
     */
    ol.format.GML3.prototype.writeGeometryElement = function(node, geometry, objectStack) {
      var context = /** @type {olx.format.WriteOptions} */ (objectStack[objectStack.length - 1]);
      var item = ol.obj.assign({}, context);
      item.node = node;
      var value;
      if (Array.isArray(geometry)) {
        Iif (context.dataProjection) {
          value = ol.proj.transformExtent(
              geometry, context.featureProjection, context.dataProjection);
        } else {
          value = geometry;
        }
      } else {
        value =
            ol.format.Feature.transformWithOptions(/** @type {ol.geom.Geometry} */ (geometry), true, context);
      }
      ol.xml.pushSerializeAndPop(/** @type {ol.XmlNodeStackItem} */
          (item), ol.format.GML3.GEOMETRY_SERIALIZERS_,
          this.GEOMETRY_NODE_FACTORY_, [value],
          objectStack, undefined, this);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.Feature} feature Feature.
     * @param {Array.<*>} objectStack Node stack.
     */
    ol.format.GML3.prototype.writeFeatureElement = function(node, feature, objectStack) {
      var fid = feature.getId();
      if (fid) {
        node.setAttribute('fid', fid);
      }
      var context = /** @type {Object} */ (objectStack[objectStack.length - 1]);
      var featureNS = context['featureNS'];
      var geometryName = feature.getGeometryName();
      if (!context.serializers) {
        context.serializers = {};
        context.serializers[featureNS] = {};
      }
      var properties = feature.getProperties();
      var keys = [], values = [];
      for (var key in properties) {
        var value = properties[key];
        if (value !== null) {
          keys.push(key);
          values.push(value);
          if (key == geometryName || value instanceof ol.geom.Geometry) {
            if (!(key in context.serializers[featureNS])) {
              context.serializers[featureNS][key] = ol.xml.makeChildAppender(
                  this.writeGeometryElement, this);
            }
          } else {
            if (!(key in context.serializers[featureNS])) {
              context.serializers[featureNS][key] = ol.xml.makeChildAppender(
                  ol.format.XSD.writeStringTextNode);
            }
          }
        }
      }
      var item = ol.obj.assign({}, context);
      item.node = node;
      ol.xml.pushSerializeAndPop(/** @type {ol.XmlNodeStackItem} */
          (item), context.serializers,
          ol.xml.makeSimpleNodeFactory(undefined, featureNS),
          values,
          objectStack, keys);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<ol.Feature>} features Features.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.GML3.prototype.writeFeatureMembers_ = function(node, features, objectStack) {
      var context = /** @type {Object} */ (objectStack[objectStack.length - 1]);
      var featureType = context['featureType'];
      var featureNS = context['featureNS'];
      var serializers = {};
      serializers[featureNS] = {};
      serializers[featureNS][featureType] = ol.xml.makeChildAppender(
          this.writeFeatureElement, this);
      var item = ol.obj.assign({}, context);
      item.node = node;
      ol.xml.pushSerializeAndPop(/** @type {ol.XmlNodeStackItem} */
          (item),
          serializers,
          ol.xml.makeSimpleNodeFactory(featureType, featureNS), features,
          objectStack);
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.SURFACEORPOLYGONMEMBER_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'surfaceMember': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeSurfaceOrPolygonMember_),
        'polygonMember': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeSurfaceOrPolygonMember_)
      }
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.POINTMEMBER_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'pointMember': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writePointMember_)
      }
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.LINESTRINGORCURVEMEMBER_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'lineStringMember': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeLineStringOrCurveMember_),
        'curveMember': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeLineStringOrCurveMember_)
      }
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.RING_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'exterior': ol.xml.makeChildAppender(ol.format.GML3.prototype.writeRing_),
        'interior': ol.xml.makeChildAppender(ol.format.GML3.prototype.writeRing_)
      }
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.GML3.GEOMETRY_SERIALIZERS_ = {
      'http://www.opengis.net/gml': {
        'Curve': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeCurveOrLineString_),
        'MultiCurve': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeMultiCurveOrLineString_),
        'Point': ol.xml.makeChildAppender(ol.format.GML3.prototype.writePoint_),
        'MultiPoint': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeMultiPoint_),
        'LineString': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeCurveOrLineString_),
        'MultiLineString': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeMultiCurveOrLineString_),
        'LinearRing': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeLinearRing_),
        'Polygon': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeSurfaceOrPolygon_),
        'MultiPolygon': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeMultiSurfaceOrPolygon_),
        'Surface': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeSurfaceOrPolygon_),
        'MultiSurface': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeMultiSurfaceOrPolygon_),
        'Envelope': ol.xml.makeChildAppender(
            ol.format.GML3.prototype.writeEnvelope)
      }
    };

    /**
     * @const
     * @type {Object.<string, string>}
     * @private
     */
    ol.format.GML3.MULTIGEOMETRY_TO_MEMBER_NODENAME_ = {
      'MultiLineString': 'lineStringMember',
      'MultiCurve': 'curveMember',
      'MultiPolygon': 'polygonMember',
      'MultiSurface': 'surfaceMember'
    };

    /**
     * @const
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node|undefined} Node.
     * @private
     */
    ol.format.GML3.prototype.MULTIGEOMETRY_MEMBER_NODE_FACTORY_ = function(value, objectStack, opt_nodeName) {
      var parentNode = objectStack[objectStack.length - 1].node;
      return ol.xml.createElementNS('http://www.opengis.net/gml',
          ol.format.GML3.MULTIGEOMETRY_TO_MEMBER_NODENAME_[parentNode.nodeName]);
    };

    /**
     * @const
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node|undefined} Node.
     * @private
     */
    ol.format.GML3.prototype.GEOMETRY_NODE_FACTORY_ = function(value, objectStack, opt_nodeName) {
      var context = objectStack[objectStack.length - 1];
      var multiSurface = context['multiSurface'];
      var surface = context['surface'];
      var curve = context['curve'];
      var multiCurve = context['multiCurve'];
      var nodeName;
      if (!Array.isArray(value)) {
        nodeName = /** @type {ol.geom.Geometry} */ (value).getType();
        if (nodeName === 'MultiPolygon' && multiSurface === true) {
          nodeName = 'MultiSurface';
        } else if (nodeName === 'Polygon' && surface === true) {
          nodeName = 'Surface';
        } else if (nodeName === 'LineString' && curve === true) {
          nodeName = 'Curve';
        } else if (nodeName === 'MultiLineString' && multiCurve === true) {
          nodeName = 'MultiCurve';
        }
      } else {
        nodeName = 'Envelope';
      }
      return ol.xml.createElementNS('http://www.opengis.net/gml',
          nodeName);
    };

    /**
     * Encode a geometry in GML 3.1.1 Simple Features.
     *
     * @param {ol.geom.Geometry} geometry Geometry.
     * @param {olx.format.WriteOptions=} opt_options Options.
     * @return {Node} Node.
     * @override
     * @api
     */
    ol.format.GML3.prototype.writeGeometryNode = function(geometry, opt_options) {
      opt_options = this.adaptOptions(opt_options);
      var geom = ol.xml.createElementNS('http://www.opengis.net/gml', 'geom');
      var context = {node: geom, hasZ: this.hasZ, srsName: this.srsName,
        curve: this.curve_, surface: this.surface_,
        multiSurface: this.multiSurface_, multiCurve: this.multiCurve_};
      Eif (opt_options) {
        ol.obj.assign(context, opt_options);
      }
      this.writeGeometryElement(geom, geometry, [context]);
      return geom;
    };

    /**
     * Encode an array of features in GML 3.1.1 Simple Features.
     *
     * @function
     * @param {Array.<ol.Feature>} features Features.
     * @param {olx.format.WriteOptions=} opt_options Options.
     * @return {string} Result.
     * @api
     */
    ol.format.GML3.prototype.writeFeatures;

    /**
     * Encode an array of features in the GML 3.1.1 format as an XML node.
     *
     * @param {Array.<ol.Feature>} features Features.
     * @param {olx.format.WriteOptions=} opt_options Options.
     * @return {Node} Node.
     * @override
     * @api
     */
    ol.format.GML3.prototype.writeFeaturesNode = function(features, opt_options) {
      opt_options = this.adaptOptions(opt_options);
      var node = ol.xml.createElementNS('http://www.opengis.net/gml',
          'featureMembers');
      ol.xml.setAttributeNS(node, 'http://www.w3.org/2001/XMLSchema-instance',
          'xsi:schemaLocation', this.schemaLocation);
      var context = {
        srsName: this.srsName,
        hasZ: this.hasZ,
        curve: this.curve_,
        surface: this.surface_,
        multiSurface: this.multiSurface_,
        multiCurve: this.multiCurve_,
        featureNS: this.featureNS,
        featureType: this.featureType
      };
      Eif (opt_options) {
        ol.obj.assign(context, opt_options);
      }
      this.writeFeatureMembers_(node, features, [context]);
      return node;
    };